/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_5 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2SImode)
      || GET_MODE (x1) != E_V2SImode
      || !reg_or_0_operand (operands[1], E_V2SImode)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern0 (x3, E_SImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern0 (x3, E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern1 (x3, E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern3 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !reg_or_u5bit_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !reg_or_0_operand (operands[1], E_SImode)
              || !reg_or_u5bit_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || !reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_u6bit_operand (operands[2], E_SImode))
            return -1;
          return 1;

        case E_V8QImode:
          if (pattern3 (x1, E_V8QImode) != 0)
            return -1;
          return 2;

        case E_V4HImode:
          if (pattern3 (x1, E_V4HImode) != 0)
            return -1;
          return 3;

        case E_V2SImode:
          if (pattern1 (x1, E_DImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case TRUNCATE:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!reg_or_u6bit_operand (operands[2], E_DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      return pattern4 (x3); /* [-1, 5] */

    case TRUNCATE:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x6;
          if (!reg_or_u5bit_operand (operands[2], E_SImode))
            return -1;
          return 6;

        case TRUNCATE:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!reg_or_0_operand (operands[2], E_DImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    case E_V8QImode:
      if (pattern0 (x3, E_V8QImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern0 (x3, E_V4HImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8QImode)
      || GET_MODE (x1) != E_V8QImode
      || !reg_or_0_operand (operands[1], E_V8QImode)
      || !reg_or_v8s8bit_operand (operands[2], E_V8QImode))
    return -1;
  return 0;
}

static int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4HImode)
      || GET_MODE (x1) != E_V4HImode
      || !reg_or_0_operand (operands[1], E_V4HImode)
      || !reg_or_v4s8bit_operand (operands[2], E_V4HImode))
    return -1;
  return 0;
}

static int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    case E_V8QImode:
      if (pattern7 (x3) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern8 (x3) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!reg_or_0_operand (operands[1], E_DImode))
    return -1;
  return pattern10 (x3); /* [-1, 1] */
}

static int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8QImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!reg_or_0_operand (operands[1], E_V8QImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!reg_or_v8s8bit_operand (operands[2], E_V8QImode))
    return -1;
  return 0;
}

static int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4HImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!reg_or_0_operand (operands[1], E_V4HImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!reg_or_v4s8bit_operand (operands[2], E_V4HImode))
    return -1;
  return 0;
}

static int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8QImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!reg_or_0_operand (operands[1], E_V8QImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!reg_or_0_operand (operands[2], E_V8QImode))
    return -1;
  return 0;
}

static int
pattern15 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

static int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !u6bit_cint_operand (operands[2], i1)
      || !u6bit_cint_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern16 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern16 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern18 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !tls_symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern18 (x3, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern18 (x3, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!reg_or_0_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!reg_or_0_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

static int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!reg_or_0_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

static int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!reg_or_0_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

static int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!reg_or_0_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!reg_or_0_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!reg_or_0_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!reg_or_u5bit_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!reg_or_0_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!reg_or_s8bit_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!pointer_operand (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (GET_MODE (x2) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case MEM:
      return pattern26 (x1); /* [-1, 2] */

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 324)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x3) != MEM)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!pointer_operand (operands[1], E_VOIDmode))
        return -1;
      switch (GET_MODE (x1))
        {
        case E_QImode:
          if (GET_MODE (x2) != E_QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          return 3;

        case E_HImode:
          if (GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          return 4;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (XVECLEN (x2, 0) != 1
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  switch (XINT (x2, 1))
    {
    case 324:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x3) != MEM)
        return -1;
      return pattern26 (x2); /* [-1, 2] */

    case 206:
      res = pattern27 (x2);
      if (res >= 0)
        return res + 3; /* [3, 8] */
      return -1;

    case 207:
      res = pattern27 (x2);
      if (res >= 0)
        return res + 9; /* [9, 14] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern29 (rtx x1, int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!reg_or_0_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode)
        return -1;
      return 0;

    case VEC_SELECT:
      if (GET_MODE (x3) != i2)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != i1)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern30 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!reg_or_0_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!reg_or_0_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

static int
pattern31 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !reg_or_s8bit_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x3, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x2, 1);
  if (GET_CODE (x8) != LABEL_REF)
    return -1;
  x9 = XEXP (x2, 2);
  if (GET_CODE (x9) != PC)
    return -1;
  x10 = XEXP (x1, 0);
  if (GET_CODE (x10) != PC)
    return -1;
  x11 = XEXP (x4, 0);
  operands[1] = x11;
  x12 = XEXP (x8, 0);
  operands[0] = x12;
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern33 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

static int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode)
    return -1;
  switch (GET_CODE (x1))
    {
    case MEM:
      x2 = XEXP (x1, 0);
      switch (GET_CODE (x2))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x2;
          if (!pointer_operand (operands[1], E_VOIDmode))
            return -1;
          return 0;

        case AND:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x3 = XEXP (x2, 1);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + -8])
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!pointer_operand (operands[1], E_VOIDmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 324)
        return -1;
      x5 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!pointer_operand (operands[1], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !add_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern36 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !and_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !const_symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || !reg_or_0_operand (operands[1], E_DImode)
      || !u6bit_cint_operand (operands[2], E_DImode)
      || !u6bit_cint_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

static int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1)
      || !reg_or_0_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern40 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

static int
pattern42 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || !reg_or_0_operand (operands[1], E_DImode)
      || !reg_or_0_operand (operands[2], E_DImode)
      || !u6bit_cint_operand (operands[3], E_DImode)
      || !u6bit_cint_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

static int
pattern44 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !tls_symbolic_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !s8bit_cint_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    case E_SImode:
      return 2;

    default:
      return -1;
    }
}

static int
pattern46 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !s8bit_cint_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_QImode:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_MODE (x7) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_MODE (x7) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return pattern46 (x1, E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern46 (x1, E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern48 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !s8bit_cint_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_QImode:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (GET_MODE (x8) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_MODE (x7) != E_HImode)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XVECEXP (x4, 0, 0);
  switch (GET_CODE (x5))
    {
    case MEM:
      return pattern47 (x1); /* [-1, 5] */

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 324)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x6) != MEM)
        return -1;
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[3]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          res = pattern48 (x1, E_SImode);
          if (res >= 0)
            return res + 6; /* [6, 8] */
          return -1;

        case E_DImode:
          res = pattern48 (x1, E_DImode);
          if (res >= 0)
            return res + 9; /* [9, 11] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case MEM:
      x8 = XEXP (x7, 0);
      if (!rtx_equal_p (x8, operands[3]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          return pattern45 (x1, E_SImode); /* [-1, 2] */

        case E_DImode:
          res = pattern45 (x1, E_DImode);
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x7, 0) != 1)
        return -1;
      switch (XINT (x7, 1))
        {
        case 324:
          x9 = XVECEXP (x7, 0, 0);
          if (GET_CODE (x9) != MEM)
            return -1;
          res = pattern47 (x1);
          if (res >= 0)
            return res + 6; /* [6, 11] */
          return -1;

        case 206:
          res = pattern49 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        case 207:
          res = pattern49 (x1);
          if (res >= 0)
            return res + 24; /* [24, 35] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern51 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!reg_or_0_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1)
      || !symbolic_operand (operands[3], i1)
      || !symbolic_operand (operands[4], i1))
    return -1;
  return 0;
}

static int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || pattern51 (i1) != 0)
    return -1;
  return 0;
}

static int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

static int
pattern55 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !reg_or_0_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonautoincmem_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonautoincmem_operand (operands[1], i1)
      || !scratch_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !nonautoincmem_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern58 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern58 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern60 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !add_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonautoincmem_operand (operands[1], i1)
      || !nonautoincmem_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern62 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !nonautoincmem_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern63 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern63 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern63 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_QImode:
      if (!reg_or_0_operand (operands[1], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!reg_or_0_operand (operands[1], E_HImode))
        return -1;
      return 2;

    case E_SImode:
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern66 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !s8bit_cint_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  return pattern65 (x5); /* [-1, 3] */
}

static int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !s8bit_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      return pattern67 (x7, E_SImode); /* [-1, 0] */

    case E_DImode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (pattern67 (x7, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case MEM:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          return pattern68 (x1); /* [-1, 1] */

        case AND:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -8])
            return -1;
          x7 = XEXP (x5, 0);
          if (!rtx_equal_p (x7, operands[3]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              x8 = XVECEXP (x1, 0, 0);
              x9 = XEXP (x8, 1);
              if (pattern67 (x9, E_SImode) != 0)
                return -1;
              return 2;

            case E_DImode:
              x8 = XVECEXP (x1, 0, 0);
              x9 = XEXP (x8, 1);
              if (pattern67 (x9, E_DImode) != 0)
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 324)
        return -1;
      x10 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x10) != MEM
          || GET_MODE (x10) != E_DImode)
        return -1;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[3]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          x8 = XVECEXP (x1, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern67 (x9, E_SImode) != 0)
            return -1;
          return 4;

        case E_DImode:
          x8 = XVECEXP (x1, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern67 (x9, E_DImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern70 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !nonautoincmem_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern72 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !s8bit_cint_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return pattern65 (x5); /* [-1, 3] */
}

static int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT
      || GET_MODE (x1) != E_V4QImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 4)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x6 = XVECEXP (x2, 0, 3);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x7 = XEXP (x1, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_V8QImode))
    return -1;
  return 0;
}

static int
pattern74 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i2
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

static int
pattern75 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i2
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

static int
pattern76 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  x8 = XVECEXP (x7, 0, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

static int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  if (GET_MODE (x8) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern78 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !tls_symbolic_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XVECEXP (x1, 0, 5);
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XVECEXP (x1, 0, 6);
  x16 = XEXP (x15, 0);
  if (GET_MODE (x16) != i1)
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && move_operand (operands[1], E_QImode)
          && 
#line 455 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))))
        return 1; /* *movqi_insn */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && move_operand (operands[1], E_HImode)
          && 
#line 478 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))))
        return 2; /* *movhi_insn */
      break;

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && move_operand (operands[1], E_SImode)
          && 
#line 502 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))))
        return 3; /* *movsi_insn */
      break;

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && move_operand (operands[1], E_DImode)
          && 
#line 527 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
((register_operand (operands[0], DImode)
    || reg_or_0_operand (operands[1], DImode))))
        return 4; /* *movdi_insn */
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && general_operand (operands[1], E_SFmode))
        return 5; /* *movsf */
      break;

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && general_operand (operands[1], E_DFmode))
        return 6; /* *movdf */
      break;

    case E_V8QImode:
      if (nonimmediate_operand (operands[0], E_V8QImode)
          && general_operand (operands[1], E_V8QImode))
        return 7; /* *movv8qi */
      break;

    case E_V4HImode:
      if (nonimmediate_operand (operands[0], E_V4HImode)
          && general_operand (operands[1], E_V4HImode))
        return 8; /* *movv4hi */
      break;

    case E_V2SImode:
      if (nonimmediate_operand (operands[0], E_V2SImode)
          && general_operand (operands[1], E_V2SImode))
        return 9; /* *movv2si */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 324)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  operands[0] = x5;
  if (!pointer_operand (operands[0], E_VOIDmode))
    return -1;
  operands[1] = x3;
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      return 409; /* insn_stnt */

    case E_QImode:
      if (!reg_or_0_operand (operands[1], E_QImode))
        return -1;
      return 412; /* *insn_stnt1 */

    case E_HImode:
      if (!reg_or_0_operand (operands[1], E_HImode))
        return -1;
      return 413; /* *insn_stnt2 */

    case E_SImode:
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      return 414; /* *insn_stnt4 */

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  if (XWINT (x3, 0) == 8L)
    {
      x5 = XEXP (x2, 2);
      if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 2])
        {
          x6 = XEXP (x1, 1);
          operands[1] = x6;
          if (register_operand (operands[1], E_DImode))
            return 13; /* *insv_tblidxb0 */
        }
    }
  operands[1] = x3;
  if (!u6bit_cint_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!u6bit_cint_operand (operands[2], E_DImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  if (!reg_or_cint_operand (operands[3], E_DImode))
    return -1;
  return 17; /* *insv_bfins */
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) != 8L)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XEXP (x2, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x2, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XEXP (x4, 2);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      switch (XWINT (x6, 0))
        {
        case 8L:
          return 14; /* *insv_tblidxb1 */

        case 16L:
          return 15; /* *insv_tblidxb2 */

        case 24L:
          return 16; /* *insv_tblidxb3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[3] = x5;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      if (!u6bit_cint_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[2] = x8;
      if (!u6bit_cint_operand (operands[2], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      x9 = XEXP (x4, 2);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      return 18; /* *insv_mm */

    default:
      return -1;
    }
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern56 (x2, E_SImode) != 0)
        return -1;
      if (reg_or_0_operand (operands[1], E_SImode))
        return 116; /* movcc_insn_sisi */
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      return 118; /* movcc_insn_disi */

    case E_DImode:
      if (pattern56 (x2, E_DImode) != 0)
        return -1;
      if (reg_or_0_operand (operands[1], E_SImode))
        return 117; /* movcc_insn_sidi */
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      return 119; /* movcc_insn_didi */

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  if (eqne_operator (operands[4], E_VOIDmode))
    {
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  switch (GET_CODE (x3))
    {
    case NE:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTRACT:
          switch (pattern32 (x1))
            {
            case 0:
              return 173; /* *blbs_normalsi */

            case 1:
              return 174; /* *blbs_normaldi */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != CONST_VECTOR)
            return -1;
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          switch (XVECLEN (x5, 0))
            {
            case 8:
              if (pattern54 (x5, E_V8QImode) != 0)
                return -1;
              x7 = XVECEXP (x5, 0, 4);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x8 = XVECEXP (x5, 0, 5);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x9 = XVECEXP (x5, 0, 6);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x10 = XVECEXP (x5, 0, 7);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !register_operand (operands[0], E_V8QImode)
                  || GET_MODE (x2) != E_V8QImode
                  || GET_MODE (x3) != E_V8QImode
                  || !reg_or_0_operand (operands[1], E_V8QImode))
                return -1;
              x11 = XEXP (x2, 2);
              if (GET_CODE (x11) == CONST_VECTOR
                  && pattern74 (x11, E_V8QImode, 8) == 0)
                {
                  x12 = XVECEXP (x11, 0, 4);
                  if (x12 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    {
                      x13 = XVECEXP (x11, 0, 5);
                      if (x13 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                        {
                          x14 = XVECEXP (x11, 0, 6);
                          if (x14 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                            {
                              x15 = XVECEXP (x11, 0, 7);
                              if (x15 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                                {
                                  x16 = XEXP (x2, 1);
                                  operands[2] = x16;
                                  if (reg_or_0_operand (operands[2], E_V8QImode))
                                    return 478; /* insn_mnz_v8qi */
                                }
                            }
                        }
                    }
                }
              x16 = XEXP (x2, 1);
              if (GET_CODE (x16) != CONST_VECTOR
                  || pattern75 (x16, E_V8QImode, 8) != 0)
                return -1;
              x17 = XVECEXP (x16, 0, 4);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x18 = XVECEXP (x16, 0, 5);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x19 = XVECEXP (x16, 0, 6);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x20 = XVECEXP (x16, 0, 7);
              if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              operands[2] = x11;
              if (!reg_or_0_operand (operands[2], E_V8QImode))
                return -1;
              return 479; /* insn_mz_v8qi */

            case 4:
              if (pattern54 (x5, E_V4HImode) != 0
                  || !register_operand (operands[0], E_V4HImode)
                  || GET_MODE (x2) != E_V4HImode
                  || GET_MODE (x3) != E_V4HImode
                  || !reg_or_0_operand (operands[1], E_V4HImode))
                return -1;
              x11 = XEXP (x2, 2);
              if (GET_CODE (x11) == CONST_VECTOR
                  && pattern74 (x11, E_V4HImode, 4) == 0)
                {
                  x16 = XEXP (x2, 1);
                  operands[2] = x16;
                  if (reg_or_0_operand (operands[2], E_V4HImode))
                    return 480; /* insn_mnz_v4hi */
                }
              x16 = XEXP (x2, 1);
              if (GET_CODE (x16) != CONST_VECTOR
                  || pattern75 (x16, E_V4HImode, 4) != 0)
                return -1;
              operands[2] = x11;
              if (!reg_or_0_operand (operands[2], E_V4HImode))
                return -1;
              return 481; /* insn_mz_v4hi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT)
        return -1;
      switch (pattern32 (x1))
        {
        case 0:
          return 175; /* *blbc_normalsi */

        case 1:
          return 176; /* *blbc_normaldi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      switch (XINT (x2, 1))
        {
        case 204:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern52 (x2, E_SImode) != 0
                  || !
#line 997 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(flag_pic))
                return -1;
              return 21; /* mov_pcrel_step3_32bit */

            case E_DImode:
              if (pattern52 (x2, E_DImode) != 0
                  || !
#line 997 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(flag_pic))
                return -1;
              return 22; /* mov_pcrel_step3 */

            default:
              return -1;
            }

        case 205:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || pattern51 (E_DImode) != 0
              || !
#line 1042 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(flag_pic))
            return -1;
          return 23; /* mov_large_pcrel_step4 */

        case 4:
          if (pattern43 (x2) != 0)
            return -1;
          return 181; /* insn_bfins */

        case 24:
          if (pattern43 (x2) != 0)
            return -1;
          return 364; /* insn_mm */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 214:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 0)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 0)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[0] = x4;
          switch (GET_MODE (x3))
            {
            case E_SImode:
              if (GET_MODE (x2) != E_SImode
                  || !tls_symbolic_operand (operands[0], E_SImode)
                  || GET_MODE (x5) != E_SImode)
                return -1;
              *pnum_clobbers = 6;
              return 24; /* *tls_gd_call_32bit */

            case E_DImode:
              if (GET_MODE (x2) != E_DImode
                  || !tls_symbolic_operand (operands[0], E_DImode)
                  || GET_MODE (x5) != E_DImode)
                return -1;
              *pnum_clobbers = 6;
              return 25; /* *tls_gd_call */

            default:
              return -1;
            }

        case 215:
          switch (pattern19 (x1))
            {
            case 0:
              return 26; /* tls_gd_add_32bit */

            case 1:
              return 27; /* tls_gd_add */

            default:
              return -1;
            }

        case 216:
          switch (pattern19 (x1))
            {
            case 0:
              return 30; /* tls_ie_load_32bit */

            case 1:
              return 31; /* tls_ie_load */

            default:
              return -1;
            }

        case 1:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern37 (x2, E_SImode) != 0)
                return -1;
              return 61; /* insn_addr_shl16insli_32bit */

            case E_DImode:
              if (pattern37 (x2, E_DImode) != 0)
                return -1;
              return 62; /* insn_addr_shl16insli */

            default:
              return -1;
            }

        case 100:
          if (pattern20 (x1) != 0)
            return -1;
          return 184; /* insn_cmul */

        case 105:
          if (pattern20 (x1) != 0)
            return -1;
          return 187; /* insn_cmulf */

        case 103:
          if (pattern20 (x1) != 0)
            return -1;
          return 188; /* insn_cmulfr */

        case 106:
          if (pattern20 (x1) != 0)
            return -1;
          return 189; /* insn_cmulh */

        case 104:
          if (pattern20 (x1) != 0)
            return -1;
          return 190; /* insn_cmulhr */

        case 5:
          if (pattern20 (x1) != 0)
            return -1;
          return 191; /* insn_crc32_32 */

        case 6:
          if (pattern20 (x1) != 0)
            return -1;
          return 192; /* insn_crc32_8 */

        case 8:
          if (pattern20 (x1) != 0)
            return -1;
          return 194; /* insn_dblalign2 */

        case 9:
          if (pattern20 (x1) != 0)
            return -1;
          return 195; /* insn_dblalign4 */

        case 10:
          if (pattern20 (x1) != 0)
            return -1;
          return 196; /* insn_dblalign6 */

        case 109:
          if (pattern20 (x1) != 0)
            return -1;
          return 200; /* insn_fdouble_add_flags */

        case 110:
          if (pattern20 (x1) != 0)
            return -1;
          return 202; /* insn_fdouble_mul_flags */

        case 111:
          if (pattern20 (x1) != 0)
            return -1;
          return 203; /* insn_fdouble_pack1 */

        case 113:
          if (pattern20 (x1) != 0)
            return -1;
          return 205; /* insn_fdouble_sub_flags */

        case 114:
          if (pattern20 (x1) != 0)
            return -1;
          return 206; /* insn_fdouble_unpack_max */

        case 115:
          if (pattern20 (x1) != 0)
            return -1;
          return 207; /* insn_fdouble_unpack_min */

        case 117:
          if (pattern20 (x1) != 0)
            return -1;
          return 220; /* insn_fsingle_add1 */

        case 119:
          if (pattern20 (x1) != 0)
            return -1;
          return 222; /* insn_fsingle_mul1 */

        case 120:
          if (pattern20 (x1) != 0)
            return -1;
          return 223; /* insn_fsingle_mul2 */

        case 122:
          if (pattern20 (x1) != 0)
            return -1;
          return 225; /* insn_fsingle_pack2 */

        case 123:
          if (pattern20 (x1) != 0)
            return -1;
          return 226; /* insn_fsingle_sub1 */

        case 135:
          if (pattern20 (x1) != 0)
            return -1;
          return 365; /* insn_mul_hs_hs */

        case 136:
          if (pattern20 (x1) != 0)
            return -1;
          return 366; /* insn_mul_hs_hu */

        case 137:
          if (pattern20 (x1) != 0)
            return -1;
          return 367; /* insn_mul_hs_ls */

        case 138:
          if (pattern20 (x1) != 0)
            return -1;
          return 368; /* insn_mul_hs_lu */

        case 139:
          if (pattern20 (x1) != 0)
            return -1;
          return 369; /* insn_mul_hu_hu */

        case 140:
          if (pattern20 (x1) != 0)
            return -1;
          return 370; /* insn_mul_hu_ls */

        case 141:
          if (pattern20 (x1) != 0)
            return -1;
          return 371; /* insn_mul_hu_lu */

        case 142:
          if (pattern20 (x1) != 0)
            return -1;
          return 372; /* insn_mul_ls_ls */

        case 143:
          if (pattern20 (x1) != 0)
            return -1;
          return 373; /* insn_mul_ls_lu */

        case 144:
          if (pattern20 (x1) != 0)
            return -1;
          return 374; /* insn_mul_lu_lu */

        case 31:
          if (pattern20 (x1) != 0)
            return -1;
          return 400; /* insn_shufflebytes1 */

        case 32:
          if (pattern20 (x1) != 0)
            return -1;
          return 421; /* insn_tblidxb0 */

        case 33:
          if (pattern20 (x1) != 0)
            return -1;
          return 422; /* insn_tblidxb1 */

        case 34:
          if (pattern20 (x1) != 0)
            return -1;
          return 423; /* insn_tblidxb2 */

        case 35:
          if (pattern20 (x1) != 0)
            return -1;
          return 424; /* insn_tblidxb3 */

        case 145:
          if (pattern20 (x1) != 0)
            return -1;
          return 489; /* insn_v1adiffu */

        case 36:
          if (pattern20 (x1) != 0)
            return -1;
          return 490; /* insn_v1avgu */

        case 146:
          if (pattern20 (x1) != 0)
            return -1;
          return 491; /* insn_v1ddotpu */

        case 148:
          if (pattern20 (x1) != 0)
            return -1;
          return 493; /* insn_v1ddotpus */

        case 150:
          if (pattern20 (x1) != 0)
            return -1;
          return 495; /* insn_v1dotp */

        case 152:
          if (pattern20 (x1) != 0)
            return -1;
          return 497; /* insn_v1dotpu */

        case 154:
          if (pattern20 (x1) != 0)
            return -1;
          return 499; /* insn_v1dotpus */

        case 157:
          if (pattern20 (x1) != 0)
            return -1;
          return 502; /* insn_v1sadu */

        case 158:
          if (pattern20 (x1) != 0)
            return -1;
          return 504; /* insn_v2adiffs */

        case 37:
          if (pattern20 (x1) != 0)
            return -1;
          return 505; /* insn_v2avgs */

        case 159:
          if (pattern20 (x1) != 0)
            return -1;
          return 506; /* insn_v2dotp */

        case 161:
          if (pattern20 (x1) != 0)
            return -1;
          return 508; /* insn_v2mulfsc */

        case 164:
          if (pattern20 (x1) != 0)
            return -1;
          return 511; /* insn_v2sads */

        case 165:
          if (pattern20 (x1) != 0)
            return -1;
          return 513; /* insn_v2sadu */

        default:
          return -1;
        }

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (XINT (x2, 1))
        {
        case 217:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern44 (x2, E_SImode) != 0)
                return -1;
              return 28; /* tls_add_32bit */

            case E_DImode:
              if (pattern44 (x2, E_DImode) != 0)
                return -1;
              return 29; /* tls_add */

            default:
              return -1;
            }

        case 2:
          if (pattern38 (x2) != 0)
            return -1;
          return 179; /* insn_bfexts */

        case 3:
          if (pattern38 (x2) != 0)
            return -1;
          return 180; /* insn_bfextu */

        case 101:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 185; /* insn_cmula */

        case 102:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 186; /* insn_cmulaf */

        case 7:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_0_operand (operands[2], E_DImode)
              || !pointer_operand (operands[3], E_VOIDmode))
            return -1;
          return 193; /* insn_dblalign */

        case 108:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 201; /* insn_fdouble_addsub */

        case 112:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 204; /* insn_fdouble_pack2 */

        case 118:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 221; /* insn_fsingle_addsub2 */

        case 125:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 375; /* insn_mula_hs_hs */

        case 126:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 376; /* insn_mula_hs_hu */

        case 127:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 377; /* insn_mula_hs_ls */

        case 128:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 378; /* insn_mula_hs_lu */

        case 129:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 379; /* insn_mula_hu_hu */

        case 130:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 380; /* insn_mula_hu_ls */

        case 131:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 381; /* insn_mula_hu_lu */

        case 132:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 382; /* insn_mula_ls_ls */

        case 133:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 383; /* insn_mula_ls_lu */

        case 134:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 384; /* insn_mula_lu_lu */

        case 124:
          if (pattern39 (x2, E_SImode) != 0)
            return -1;
          return 385; /* insn_mulax */

        case 31:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 399; /* insn_shufflebytes */

        case 147:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 492; /* insn_v1ddotpua */

        case 149:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 494; /* insn_v1ddotpusa */

        case 151:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 496; /* insn_v1dotpa */

        case 153:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 498; /* insn_v1dotpua */

        case 155:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 500; /* insn_v1dotpusa */

        case 156:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 501; /* insn_v1sadau */

        case 160:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 507; /* insn_v2dotpa */

        case 162:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 509; /* insn_v2sadas */

        case 163:
          if (pattern39 (x2, E_DImode) != 0)
            return -1;
          return 510; /* insn_v2sadau */

        default:
          return -1;
        }

    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (XINT (x2, 1))
        {
        case 121:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!reg_or_0_operand (operands[1], E_DImode))
            return -1;
          return 224; /* insn_fsingle_pack1 */

        case 324:
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_DImode)
            return -1;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (!pointer_operand (operands[1], E_VOIDmode))
            return -1;
          return 250; /* insn_ldnt */

        case 206:
          x4 = XVECEXP (x2, 0, 0);
          switch (pattern34 (x4))
            {
            case 0:
              return 271; /* insn_ld_L2 */

            case 1:
              return 274; /* insn_ldna_L2 */

            case 2:
              return 295; /* insn_ldnt_L2 */

            default:
              return -1;
            }

        case 207:
          x4 = XVECEXP (x2, 0, 0);
          switch (pattern34 (x4))
            {
            case 0:
              return 316; /* insn_ld_miss */

            case 1:
              return 319; /* insn_ldna_miss */

            case 2:
              return 340; /* insn_ldnt_miss */

            default:
              return -1;
            }

        case 22:
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 361; /* insn_lnk */

        case 30:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!reg_or_0_operand (operands[1], E_DImode))
            return -1;
          return 392; /* insn_revbits */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_CONCAT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  switch (XVECLEN (x4, 0))
    {
    case 8:
      if (pattern41 (x4) != 0)
        return -1;
      x8 = XVECEXP (x4, 0, 4);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x4, 0, 5);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x4, 0, 6);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x4, 0, 7);
      if (GET_CODE (x11) != CONST_INT
          || pattern55 (x2, E_V8QImode, E_V16QImode) != 0)
        return -1;
      x12 = XVECEXP (x4, 0, 0);
      switch (XWINT (x12, 0))
        {
        case 0L:
          x13 = XVECEXP (x4, 0, 1);
          if (XWINT (x13, 0) != 8L)
            return -1;
          x14 = XVECEXP (x4, 0, 2);
          if (XWINT (x14, 0) != 1L)
            return -1;
          x15 = XVECEXP (x4, 0, 3);
          if (XWINT (x15, 0) != 9L
              || XWINT (x8, 0) != 2L
              || XWINT (x9, 0) != 10L
              || XWINT (x10, 0) != 3L
              || XWINT (x11, 0) != 11L)
            return -1;
          if (
#line 4504 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(BYTES_BIG_ENDIAN))
            return 466; /* vec_interleave_highv8qi_be */
          if (!
#line 4579 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(!BYTES_BIG_ENDIAN))
            return -1;
          return 469; /* vec_interleave_lowv8qi_le */

        case 4L:
          x13 = XVECEXP (x4, 0, 1);
          if (XWINT (x13, 0) != 12L)
            return -1;
          x14 = XVECEXP (x4, 0, 2);
          if (XWINT (x14, 0) != 5L)
            return -1;
          x15 = XVECEXP (x4, 0, 3);
          if (XWINT (x15, 0) != 13L
              || XWINT (x8, 0) != 6L
              || XWINT (x9, 0) != 14L
              || XWINT (x10, 0) != 7L
              || XWINT (x11, 0) != 15L)
            return -1;
          if (
#line 4517 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(!BYTES_BIG_ENDIAN))
            return 467; /* vec_interleave_highv8qi_le */
          if (!
#line 4566 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(BYTES_BIG_ENDIAN))
            return -1;
          return 468; /* vec_interleave_lowv8qi_be */

        default:
          return -1;
        }

    case 4:
      if (pattern41 (x4) != 0
          || pattern55 (x2, E_V4HImode, E_V8HImode) != 0)
        return -1;
      x12 = XVECEXP (x4, 0, 0);
      switch (XWINT (x12, 0))
        {
        case 0L:
          x13 = XVECEXP (x4, 0, 1);
          if (XWINT (x13, 0) != 4L)
            return -1;
          x14 = XVECEXP (x4, 0, 2);
          if (XWINT (x14, 0) != 1L)
            return -1;
          x15 = XVECEXP (x4, 0, 3);
          if (XWINT (x15, 0) != 5L)
            return -1;
          if (
#line 4626 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(BYTES_BIG_ENDIAN))
            return 470; /* vec_interleave_highv4hi_be */
          if (!
#line 4695 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(!BYTES_BIG_ENDIAN))
            return -1;
          return 473; /* vec_interleave_lowv4hi_le */

        case 2L:
          x13 = XVECEXP (x4, 0, 1);
          if (XWINT (x13, 0) != 6L)
            return -1;
          x14 = XVECEXP (x4, 0, 2);
          if (XWINT (x14, 0) != 3L)
            return -1;
          x15 = XVECEXP (x4, 0, 3);
          if (XWINT (x15, 0) != 7L)
            return -1;
          if (
#line 4637 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(!BYTES_BIG_ENDIAN))
            return 471; /* vec_interleave_highv4hi_le */
          if (!
#line 4684 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(BYTES_BIG_ENDIAN))
            return -1;
          return 472; /* vec_interleave_lowv4hi_be */

        default:
          return -1;
        }

    case 2:
      x12 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x13) != CONST_INT
          || pattern55 (x2, E_V2SImode, E_V4SImode) != 0)
        return -1;
      switch (XWINT (x12, 0))
        {
        case 0L:
          if (XWINT (x13, 0) != 2L)
            return -1;
          if (
#line 4741 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(BYTES_BIG_ENDIAN))
            return 474; /* vec_interleave_highv2si_be */
          if (!
#line 4807 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(!BYTES_BIG_ENDIAN))
            return -1;
          return 477; /* vec_interleave_lowv2si_le */

        case 1L:
          if (XWINT (x13, 0) != 3L)
            return -1;
          if (
#line 4751 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(!BYTES_BIG_ENDIAN))
            return 475; /* vec_interleave_highv2si_le */
          if (!
#line 4797 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(BYTES_BIG_ENDIAN))
            return -1;
          return 476; /* vec_interleave_lowv2si_be */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern35 (x3, E_SImode) != 0)
            return -1;
          return 37; /* addsi3 */

        case E_DImode:
          if (pattern35 (x3, E_DImode) != 0)
            return -1;
          return 38; /* adddi3 */

        case E_V8QImode:
          if (pattern7 (x3) != 0)
            return -1;
          return 425; /* addv8qi3 */

        case E_V4HImode:
          if (pattern8 (x3) != 0)
            return -1;
          return 434; /* addv4hi3 */

        case E_V2SImode:
          if (pattern1 (x3, E_V2SImode) != 0)
            return -1;
          return 461; /* addv2si3 */

        default:
          return -1;
        }

    case TRUNCATE:
      if (pattern21 (x3, E_SImode) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST:
        case REG:
        case SUBREG:
          operands[2] = x5;
          if (!add_operand (operands[2], E_SImode))
            return -1;
          return 134; /* *addsi_truncdisi */

        case TRUNCATE:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!reg_or_0_operand (operands[2], E_DImode))
            return -1;
          return 135; /* *addsi_truncdisi2 */

        default:
          return -1;
        }

    case MULT:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          if (pattern30 (x3, SIGN_EXTEND) != 0)
            return -1;
          return 148; /* maddsidi4 */

        case ZERO_EXTEND:
          if (pattern30 (x3, ZERO_EXTEND) != 0)
            return -1;
          return 149; /* umaddsidi4 */

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x7;
          x8 = XEXP (x4, 1);
          if (GET_CODE (x8) != CONST_INT)
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (XWINT (x8, 0))
            {
            case 2L:
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern53 (x3, E_DImode) != 0)
                    return -1;
                  return 393; /* insn_shl1add */

                case E_SImode:
                  if (pattern53 (x3, E_SImode) != 0)
                    return -1;
                  return 394; /* insn_shl1addx */

                default:
                  return -1;
                }

            case 4L:
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern53 (x3, E_DImode) != 0)
                    return -1;
                  return 395; /* insn_shl2add */

                case E_SImode:
                  if (pattern53 (x3, E_SImode) != 0)
                    return -1;
                  return 396; /* insn_shl2addx */

                default:
                  return -1;
                }

            case 8L:
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern53 (x3, E_DImode) != 0)
                    return -1;
                  return 397; /* insn_shl3add */

                case E_SImode:
                  if (pattern53 (x3, E_SImode) != 0)
                    return -1;
                  return 398; /* insn_shl3addx */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (pnum_clobbers == NULL
          || XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 209
          || GET_MODE (x4) != E_DImode)
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 67
          || GET_MODE (x9) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x10 = XVECEXP (x4, 0, 0);
      operands[1] = x10;
      if (!netreg_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!add_operand (operands[2], E_DImode))
        return -1;
      *pnum_clobbers = 1;
      return 520; /* *netreg_adddi_from_network */

    default:
      return -1;
    }
}

static int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern0 (x3, E_SImode) != 0)
            return -1;
          return 144; /* mulsi3 */

        case E_V8QImode:
          if (pattern0 (x3, E_V8QImode) != 0)
            return -1;
          return 449; /* mulv8qi3 */

        case E_V4HImode:
          if (pattern0 (x3, E_V4HImode) != 0)
            return -1;
          return 456; /* mulv4hi3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND)
        return -1;
      switch (pattern29 (x3, 2, E_V2HImode))
        {
        case 0:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!reg_or_0_operand (operands[2], E_SImode))
            return -1;
          return 145; /* mulsidi3 */

        case 1:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != VEC_SELECT
              || GET_MODE (x6) != E_V2HImode)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PARALLEL
              || XVECLEN (x7, 0) != 2)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XVECEXP (x7, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || GET_MODE (x4) != E_V2SImode)
            return -1;
          x10 = XEXP (x4, 0);
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_V4HImode)
              || GET_MODE (x5) != E_V2SImode)
            return -1;
          x12 = XEXP (x6, 0);
          operands[2] = x12;
          if (!register_operand (operands[2], E_V4HImode))
            return -1;
          return 484; /* vec_widen_smult_lo_v4qi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern29 (x3, 4, E_V4QImode))
        {
        case 0:
          x5 = XEXP (x3, 1);
          if (GET_MODE (x5) != E_DImode)
            return -1;
          switch (GET_CODE (x5))
            {
            case ZERO_EXTEND:
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (!reg_or_0_operand (operands[2], E_SImode))
                return -1;
              return 146; /* umulsidi3 */

            case SIGN_EXTEND:
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (!reg_or_0_operand (operands[2], E_SImode))
                return -1;
              return 147; /* usmulsidi3 */

            default:
              return -1;
            }

        case 1:
          x10 = XEXP (x4, 0);
          x13 = XEXP (x10, 1);
          x14 = XVECEXP (x13, 0, 2);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x15 = XVECEXP (x13, 0, 3);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || !register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || GET_MODE (x4) != E_V4HImode)
            return -1;
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_MODE (x5) != E_V4HImode)
            return -1;
          switch (GET_CODE (x5))
            {
            case ZERO_EXTEND:
              x6 = XEXP (x5, 0);
              if (pattern73 (x6) != 0)
                return -1;
              return 482; /* vec_widen_umult_lo_v8qi */

            case SIGN_EXTEND:
              x6 = XEXP (x5, 0);
              if (pattern73 (x6) != 0)
                return -1;
              return 483; /* vec_widen_usmult_lo_v8qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 202:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !symbolic_operand (operands[1], E_SImode))
                return -1;
              return 19; /* insn_lnk_and_label_32bit */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !symbolic_operand (operands[1], E_DImode))
                return -1;
              return 20; /* insn_lnk_and_label */

            default:
              return -1;
            }

        case 203:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          if (!rtx_equal_p (x4, operands[0]))
            return -1;
          return 177; /* *memory_barrier */

        case 213:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 66)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[0] = x4;
          switch (GET_MODE (x3))
            {
            case E_SImode:
              if (GET_MODE (x2) != E_SImode
                  || !reg_or_0_operand (operands[0], E_SImode))
                return -1;
              return 525; /* mtspr_cmpexchsi */

            case E_DImode:
              if (GET_MODE (x2) != E_DImode
                  || !reg_or_0_operand (operands[0], E_DImode))
                return -1;
              return 526; /* mtspr_cmpexchdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (pnum_clobbers == NULL
          || XINT (x2, 1) != 209
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 67
          || GET_MODE (x5) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!netreg_operand (operands[1], E_DImode))
        return -1;
      *pnum_clobbers = 1;
      return 517; /* *netreg_receive */

    default:
      return -1;
    }
}

static int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern22 (x3) != 0
          || !add_operand (operands[2], E_SImode))
        return -1;
      return 39; /* *addsi3_sext */

    case MINUS:
      if (pattern23 (x3) != 0)
        return -1;
      return 42; /* *subsi3_sext */

    case NEG:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      return 45; /* *negsi2_sext */

    case SS_PLUS:
      if (pattern23 (x3) != 0)
        return -1;
      return 47; /* *ssaddsi3_sext */

    case SS_MINUS:
      if (pattern23 (x3) != 0)
        return -1;
      return 49; /* *sssubsi3_sext */

    case ASHIFT:
      if (pattern24 (x3) != 0)
        return -1;
      return 52; /* *ashlsi3_sext */

    case ASHIFTRT:
      if (pattern24 (x3) != 0)
        return -1;
      return 55; /* *ashrsi3_sext */

    case LSHIFTRT:
      if (pattern24 (x3) != 0)
        return -1;
      return 58; /* *lshrsi3_sext */

    case AND:
      if (pattern22 (x3) != 0
          || !and_operand (operands[2], E_SImode))
        return -1;
      return 91; /* *andsi3_sext */

    case IOR:
      if (pattern25 (x3) != 0)
        return -1;
      return 98; /* *iorsi3_sext */

    case XOR:
      if (pattern25 (x3) != 0)
        return -1;
      return 104; /* *xorsi3_sext */

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      switch (pattern10 (x3))
        {
        case 0:
          if (move_operand (operands[1], E_QImode))
            return 125; /* extendqisi2 */
          if (!move_operand (operands[1], E_HImode))
            return -1;
          return 127; /* extendhisi2 */

        case 1:
          if (move_operand (operands[1], E_QImode))
            return 126; /* extendqidi2 */
          if (move_operand (operands[1], E_HImode))
            return 128; /* extendhidi2 */
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 129; /* extendsidi2 */

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern28 (x3))
        {
        case 0:
          return 253; /* insn_ldnt1s */

        case 1:
          return 255; /* insn_ldnt2s */

        case 2:
          return 257; /* insn_ldnt4s */

        case 3:
          return 277; /* insn_ld1s_L2 */

        case 4:
          return 279; /* insn_ld2s_L2 */

        case 5:
          return 281; /* insn_ld4s_L2 */

        case 6:
          return 298; /* insn_ldnt1s_L2 */

        case 7:
          return 300; /* insn_ldnt2s_L2 */

        case 8:
          return 302; /* insn_ldnt4s_L2 */

        case 9:
          return 322; /* insn_ld1s_miss */

        case 10:
          return 324; /* insn_ld2s_miss */

        case 11:
          return 326; /* insn_ld4s_miss */

        case 12:
          return 343; /* insn_ldnt1s_miss */

        case 13:
          return 345; /* insn_ldnt2s_miss */

        case 14:
          return 347; /* insn_ldnt4s_miss */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case TRUNCATE:
      if (GET_MODE (x4) != E_V4QImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != TRUNCATE
          || GET_MODE (x5) != E_V4QImode
          || !register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!reg_or_0_operand (operands[1], E_V4HImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!reg_or_0_operand (operands[2], E_V4HImode))
            return -1;
          return 485; /* vec_pack_trunc_v4hi */

        case ASHIFTRT:
          if (GET_MODE (x6) != E_V4HImode)
            return -1;
          x8 = XEXP (x6, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != ASHIFTRT
              || GET_MODE (x7) != E_V4HImode)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x10 = XEXP (x6, 0);
          operands[1] = x10;
          if (!reg_or_0_operand (operands[1], E_V4HImode))
            return -1;
          x11 = XEXP (x7, 0);
          operands[2] = x11;
          if (!reg_or_0_operand (operands[2], E_V4HImode))
            return -1;
          return 487; /* vec_pack_hipart_v4hi */

        default:
          return -1;
        }

    case US_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != US_TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern42 (x3, E_V4HImode, E_V4QImode, E_V8QImode) != 0)
            return -1;
          return 486; /* vec_pack_usat_v4hi */

        case E_V4HImode:
          if (pattern42 (x3, E_V2SImode, E_V2HImode, E_V4HImode) != 0)
            return -1;
          return 488; /* vec_pack_ssat_v2si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case STRICT_LOW_PART:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XEXP (x1, 1);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (register_operand (operands[0], E_QImode)
              && reg_or_0_operand (operands[1], E_QImode))
            return 10; /* movstrictqi */
          break;

        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && reg_or_0_operand (operands[1], E_HImode))
            return 11; /* movstricthi */
          break;

        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && reg_or_0_operand (operands[1], E_SImode))
            return 12; /* movstrictsi */
          break;

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x4 = XEXP (x1, 1);
      operands[0] = x4;
      if (pointer_operand (operands[0], E_VOIDmode))
        return 159; /* indirect_jump */
      break;

    default:
      break;
    }
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case LABEL_REF:
      if (GET_CODE (x2) != PC)
        return -1;
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      return 158; /* jump */

    case MEM:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != AND
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -8])
        return -1;
      operands[0] = x2;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!pointer_operand (operands[1], E_VOIDmode))
        return -1;
      return 235; /* insn_ldna */

    default:
      return -1;
    }
}

static int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case PC:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LABEL_REF)
        return -1;
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      if (!pointer_operand (operands[0], E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      return 161; /* tablejump_aux */

    case REG:
    case SUBREG:
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_BLKmode)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != SCRATCH)
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 165; /* sp_restore_32bit */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode))
            return -1;
          return 166; /* sp_restore */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!pointer_operand (operands[1], E_VOIDmode))
    return -1;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (XVECLEN (x3, 0))
    {
    case 3:
      if (XINT (x3, 1) != 200)
        return -1;
      x10 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x10) != MEM)
        return -1;
      x11 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 66)
        return -1;
      x12 = XVECEXP (x3, 0, 2);
      operands[2] = x12;
      x13 = XEXP (x10, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern77 (x1, E_SImode) != 0)
            return -1;
          return 182; /* insn_cmpexch4 */

        case E_DImode:
          if (pattern77 (x1, E_DImode) != 0)
            return -1;
          return 183; /* insn_cmpexch */

        default:
          return -1;
        }

    case 1:
      if (XINT (x3, 1) != 107)
        return -1;
      x10 = XVECEXP (x3, 0, 0);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern70 (x1, E_SImode) != 0)
            return -1;
          return 198; /* insn_exch4 */

        case E_DImode:
          if (pattern70 (x1, E_DImode) != 0)
            return -1;
          return 199; /* insn_exch */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern15 (x4, 54, USE) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (pnum_clobbers != NULL)
        {
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          if (call_address_operand (operands[0], E_SImode))
            {
              *pnum_clobbers = 1;
              return 150; /* *call_insn */
            }
          if (call_address_operand (operands[0], E_DImode))
            {
              *pnum_clobbers = 1;
              return 151; /* *call_insn */
            }
        }
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (call_address_operand (operands[0], E_SImode)
          && 
#line 2624 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(SIBLING_CALL_P(insn)))
        return 154; /* *sibcall_insn */
      if (!call_address_operand (operands[0], E_DImode)
          || !
#line 2624 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(SIBLING_CALL_P(insn)))
        return -1;
      return 155; /* *sibcall_insn */

    case SET:
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case CALL:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_DImode
              || pattern33 (x1, 54, USE) != 0)
            return -1;
          if (pnum_clobbers != NULL
              && register_operand (operands[0], E_VOIDmode))
            {
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              x9 = XEXP (x6, 1);
              operands[2] = x9;
              if (call_address_operand (operands[1], E_SImode))
                {
                  *pnum_clobbers = 1;
                  return 152; /* *call_value_insn */
                }
              if (call_address_operand (operands[1], E_DImode))
                {
                  *pnum_clobbers = 1;
                  return 153; /* *call_value_insn */
                }
            }
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          operands[2] = x9;
          if (call_address_operand (operands[1], E_SImode)
              && 
#line 2643 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(SIBLING_CALL_P(insn)))
            return 156; /* *sibcall_value */
          if (!call_address_operand (operands[1], E_DImode)
              || !
#line 2643 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(SIBLING_CALL_P(insn)))
            return -1;
          return 157; /* *sibcall_value */

        case PLUS:
          x9 = XEXP (x6, 1);
          operands[2] = x9;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              x4 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x4))
                {
                case CLOBBER:
                  x10 = XEXP (x4, 0);
                  if (GET_CODE (x10) != MEM
                      || GET_MODE (x10) != E_BLKmode)
                    return -1;
                  x11 = XEXP (x10, 0);
                  if (GET_CODE (x11) != SCRATCH)
                    return -1;
                  x3 = XEXP (x2, 0);
                  operands[0] = x3;
                  operands[1] = x7;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_DImode:
                      if (pattern60 (x6, E_DImode) != 0)
                        return -1;
                      return 163; /* sp_adjust */

                    case E_SImode:
                      if (pattern60 (x6, E_SImode) != 0)
                        return -1;
                      return 164; /* sp_adjust_32bit */

                    default:
                      return -1;
                    }

                case SET:
                  operands[3] = x7;
                  x12 = XEXP (x4, 1);
                  switch (GET_CODE (x12))
                    {
                    case MEM:
                      if (GET_MODE (x12) != E_DImode)
                        return -1;
                      x3 = XEXP (x2, 0);
                      operands[1] = x3;
                      x10 = XEXP (x4, 0);
                      operands[0] = x10;
                      if (!register_operand (operands[0], E_DImode))
                        return -1;
                      x13 = XEXP (x12, 0);
                      switch (GET_CODE (x13))
                        {
                        case REG:
                        case SUBREG:
                          if (!rtx_equal_p (x13, operands[3]))
                            return -1;
                          switch (GET_MODE (operands[1]))
                            {
                            case E_SImode:
                              if (pattern67 (x6, E_SImode) != 0)
                                return -1;
                              return 233; /* insn_ld_add_32bit */

                            case E_DImode:
                              if (pattern67 (x6, E_DImode) != 0)
                                return -1;
                              return 234; /* insn_ld_add */

                            default:
                              return -1;
                            }

                        case AND:
                          if (GET_MODE (x13) != E_DImode)
                            return -1;
                          x14 = XEXP (x13, 1);
                          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -8])
                            return -1;
                          x15 = XEXP (x13, 0);
                          if (!rtx_equal_p (x15, operands[3]))
                            return -1;
                          switch (GET_MODE (operands[1]))
                            {
                            case E_SImode:
                              if (pattern67 (x6, E_SImode) != 0)
                                return -1;
                              return 236; /* insn_ldna_add_32bit */

                            case E_DImode:
                              if (pattern67 (x6, E_DImode) != 0)
                                return -1;
                              return 237; /* insn_ldna_add */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    case SIGN_EXTEND:
                      switch (pattern50 (x1))
                        {
                        case 0:
                          return 238; /* insn_ld1s_add_32bit */

                        case 1:
                          return 242; /* insn_ld2s_add_32bit */

                        case 2:
                          return 246; /* insn_ld4s_add_32bit */

                        case 3:
                          return 240; /* insn_ld1s_add */

                        case 4:
                          return 244; /* insn_ld2s_add */

                        case 5:
                          return 248; /* insn_ld4s_add */

                        case 6:
                          return 259; /* insn_ldnt1s_add_32bit */

                        case 7:
                          return 263; /* insn_ldnt2s_add_32bit */

                        case 8:
                          return 267; /* insn_ldnt4s_add_32bit */

                        case 9:
                          return 261; /* insn_ldnt1s_add */

                        case 10:
                          return 265; /* insn_ldnt2s_add */

                        case 11:
                          return 269; /* insn_ldnt4s_add */

                        case 12:
                          return 283; /* insn_ld1s_add_L2_32bit */

                        case 13:
                          return 287; /* insn_ld2s_add_L2_32bit */

                        case 14:
                          return 291; /* insn_ld4s_add_L2_32bit */

                        case 15:
                          return 285; /* insn_ld1s_add_L2 */

                        case 16:
                          return 289; /* insn_ld2s_add_L2 */

                        case 17:
                          return 293; /* insn_ld4s_add_L2 */

                        case 18:
                          return 304; /* insn_ldnt1s_add_L2_32bit */

                        case 19:
                          return 308; /* insn_ldnt2s_add_L2_32bit */

                        case 20:
                          return 312; /* insn_ldnt4s_add_L2_32bit */

                        case 21:
                          return 306; /* insn_ldnt1s_add_L2 */

                        case 22:
                          return 310; /* insn_ldnt2s_add_L2 */

                        case 23:
                          return 314; /* insn_ldnt4s_add_L2 */

                        case 24:
                          return 328; /* insn_ld1s_add_miss_32bit */

                        case 25:
                          return 332; /* insn_ld2s_add_miss_32bit */

                        case 26:
                          return 336; /* insn_ld4s_add_miss_32bit */

                        case 27:
                          return 330; /* insn_ld1s_add_miss */

                        case 28:
                          return 334; /* insn_ld2s_add_miss */

                        case 29:
                          return 338; /* insn_ld4s_add_miss */

                        case 30:
                          return 349; /* insn_ldnt1s_add_miss_32bit */

                        case 31:
                          return 353; /* insn_ldnt2s_add_miss_32bit */

                        case 32:
                          return 357; /* insn_ldnt4s_add_miss_32bit */

                        case 33:
                          return 351; /* insn_ldnt1s_add_miss */

                        case 34:
                          return 355; /* insn_ldnt2s_add_miss */

                        case 35:
                          return 359; /* insn_ldnt4s_add_miss */

                        default:
                          return -1;
                        }

                    case ZERO_EXTEND:
                      switch (pattern50 (x1))
                        {
                        case 0:
                          return 239; /* insn_ld1u_add_32bit */

                        case 1:
                          return 243; /* insn_ld2u_add_32bit */

                        case 2:
                          return 247; /* insn_ld4u_add_32bit */

                        case 3:
                          return 241; /* insn_ld1u_add */

                        case 4:
                          return 245; /* insn_ld2u_add */

                        case 5:
                          return 249; /* insn_ld4u_add */

                        case 6:
                          return 260; /* insn_ldnt1u_add_32bit */

                        case 7:
                          return 264; /* insn_ldnt2u_add_32bit */

                        case 8:
                          return 268; /* insn_ldnt4u_add_32bit */

                        case 9:
                          return 262; /* insn_ldnt1u_add */

                        case 10:
                          return 266; /* insn_ldnt2u_add */

                        case 11:
                          return 270; /* insn_ldnt4u_add */

                        case 12:
                          return 284; /* insn_ld1u_add_L2_32bit */

                        case 13:
                          return 288; /* insn_ld2u_add_L2_32bit */

                        case 14:
                          return 292; /* insn_ld4u_add_L2_32bit */

                        case 15:
                          return 286; /* insn_ld1u_add_L2 */

                        case 16:
                          return 290; /* insn_ld2u_add_L2 */

                        case 17:
                          return 294; /* insn_ld4u_add_L2 */

                        case 18:
                          return 305; /* insn_ldnt1u_add_L2_32bit */

                        case 19:
                          return 309; /* insn_ldnt2u_add_L2_32bit */

                        case 20:
                          return 313; /* insn_ldnt4u_add_L2_32bit */

                        case 21:
                          return 307; /* insn_ldnt1u_add_L2 */

                        case 22:
                          return 311; /* insn_ldnt2u_add_L2 */

                        case 23:
                          return 315; /* insn_ldnt4u_add_L2 */

                        case 24:
                          return 329; /* insn_ld1u_add_miss_32bit */

                        case 25:
                          return 333; /* insn_ld2u_add_miss_32bit */

                        case 26:
                          return 337; /* insn_ld4u_add_miss_32bit */

                        case 27:
                          return 331; /* insn_ld1u_add_miss */

                        case 28:
                          return 335; /* insn_ld2u_add_miss */

                        case 29:
                          return 339; /* insn_ld4u_add_miss */

                        case 30:
                          return 350; /* insn_ldnt1u_add_miss_32bit */

                        case 31:
                          return 354; /* insn_ldnt2u_add_miss_32bit */

                        case 32:
                          return 358; /* insn_ldnt4u_add_miss_32bit */

                        case 33:
                          return 352; /* insn_ldnt1u_add_miss */

                        case 34:
                          return 356; /* insn_ldnt2u_add_miss */

                        case 35:
                          return 360; /* insn_ldnt4u_add_miss */

                        default:
                          return -1;
                        }

                    case UNSPEC:
                      if (XVECLEN (x12, 0) != 1)
                        return -1;
                      x3 = XEXP (x2, 0);
                      operands[1] = x3;
                      x10 = XEXP (x4, 0);
                      operands[0] = x10;
                      if (!register_operand (operands[0], E_DImode)
                          || GET_MODE (x12) != E_DImode)
                        return -1;
                      x16 = XVECEXP (x12, 0, 0);
                      if (GET_MODE (x16) != E_DImode)
                        return -1;
                      switch (XINT (x12, 1))
                        {
                        case 324:
                          if (GET_CODE (x16) != MEM)
                            return -1;
                          switch (pattern68 (x1))
                            {
                            case 0:
                              return 251; /* insn_ldnt_add_32bit */

                            case 1:
                              return 252; /* insn_ldnt_add */

                            default:
                              return -1;
                            }

                        case 206:
                          switch (pattern69 (x1))
                            {
                            case 0:
                              return 272; /* insn_ld_add_L2_32bit */

                            case 1:
                              return 273; /* insn_ld_add_L2 */

                            case 2:
                              return 275; /* insn_ldna_add_L2_32bit */

                            case 3:
                              return 276; /* insn_ldna_add_L2 */

                            case 4:
                              return 296; /* insn_ldnt_add_L2_32bit */

                            case 5:
                              return 297; /* insn_ldnt_add_L2 */

                            default:
                              return -1;
                            }

                        case 207:
                          switch (pattern69 (x1))
                            {
                            case 0:
                              return 317; /* insn_ld_add_miss_32bit */

                            case 1:
                              return 318; /* insn_ld_add_miss */

                            case 2:
                              return 320; /* insn_ldna_add_miss_32bit */

                            case 3:
                              return 321; /* insn_ldna_add_miss */

                            case 4:
                              return 341; /* insn_ldnt_add_miss_32bit */

                            case 5:
                              return 342; /* insn_ldnt_add_miss */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    case CONST_INT:
                    case CONST_DOUBLE:
                    case CONST_VECTOR:
                    case REG:
                    case SUBREG:
                      operands[1] = x12;
                      x10 = XEXP (x4, 0);
                      if (GET_CODE (x10) != MEM)
                        return -1;
                      x3 = XEXP (x2, 0);
                      operands[0] = x3;
                      x11 = XEXP (x10, 0);
                      switch (GET_CODE (x11))
                        {
                        case REG:
                        case SUBREG:
                          if (!rtx_equal_p (x11, operands[3]))
                            return -1;
                          switch (GET_MODE (operands[0]))
                            {
                            case E_SImode:
                              switch (pattern66 (x1, E_SImode))
                                {
                                case 0:
                                  return 401; /* insn_st_add_32bit */

                                case 1:
                                  return 403; /* *insn_st1_add_32bit */

                                case 2:
                                  return 405; /* *insn_st2_add_32bit */

                                case 3:
                                  return 407; /* *insn_st4_add_32bit */

                                default:
                                  return -1;
                                }

                            case E_DImode:
                              switch (pattern66 (x1, E_DImode))
                                {
                                case 0:
                                  return 402; /* insn_st_add */

                                case 1:
                                  return 404; /* *insn_st1_add */

                                case 2:
                                  return 406; /* *insn_st2_add */

                                case 3:
                                  return 408; /* *insn_st4_add */

                                default:
                                  return -1;
                                }

                            default:
                              return -1;
                            }

                        case UNSPEC:
                          if (XVECLEN (x11, 0) != 1
                              || XINT (x11, 1) != 324)
                            return -1;
                          x17 = XVECEXP (x11, 0, 0);
                          if (!rtx_equal_p (x17, operands[3]))
                            return -1;
                          switch (GET_MODE (operands[0]))
                            {
                            case E_SImode:
                              switch (pattern72 (x1, E_SImode))
                                {
                                case 0:
                                  return 410; /* insn_stnt_add_32bit */

                                case 1:
                                  return 415; /* *insn_stnt1_add_32bit */

                                case 2:
                                  return 417; /* *insn_stnt2_add_32bit */

                                case 3:
                                  return 419; /* *insn_stnt4_add_32bit */

                                default:
                                  return -1;
                                }

                            case E_DImode:
                              switch (pattern72 (x1, E_DImode))
                                {
                                case 0:
                                  return 411; /* insn_stnt_add */

                                case 1:
                                  return 416; /* *insn_stnt1_add */

                                case 2:
                                  return 418; /* *insn_stnt2_add */

                                case 3:
                                  return 420; /* *insn_stnt4_add */

                                default:
                                  return -1;
                                }

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x7, 0) != 2
                  || XINT (x7, 1) != 209
                  || GET_MODE (x7) != E_DImode)
                return -1;
              x18 = XVECEXP (x7, 0, 1);
              if (GET_CODE (x18) != REG
                  || REGNO (x18) != 67
                  || GET_MODE (x18) != E_DImode
                  || pattern33 (x1, 67, CLOBBER) != 0
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x6) != E_DImode)
                return -1;
              x19 = XVECEXP (x7, 0, 0);
              operands[1] = x19;
              if (!netreg_operand (operands[1], E_DImode)
                  || !add_operand (operands[2], E_DImode))
                return -1;
              return 520; /* *netreg_adddi_from_network */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          switch (XVECLEN (x6, 0))
            {
            case 1:
              switch (XINT (x6, 1))
                {
                case 218:
                  x20 = XVECEXP (x6, 0, 0);
                  if (GET_CODE (x20) != MEM)
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != SET)
                    return -1;
                  x10 = XEXP (x4, 0);
                  if (GET_CODE (x10) != MEM)
                    return -1;
                  x21 = XEXP (x20, 0);
                  operands[1] = x21;
                  if (!pointer_operand (operands[1], E_VOIDmode))
                    return -1;
                  x11 = XEXP (x10, 0);
                  if (!rtx_equal_p (x11, operands[1]))
                    return -1;
                  x12 = XEXP (x4, 1);
                  switch (GET_CODE (x12))
                    {
                    case PLUS:
                      switch (pattern64 (x1))
                        {
                        case 0:
                          return 208; /* insn_fetchadd4 */

                        case 1:
                          return 209; /* insn_fetchadd */

                        default:
                          return -1;
                        }

                    case UNSPEC:
                      if (XVECLEN (x12, 0) != 2
                          || XINT (x12, 1) != 116)
                        return -1;
                      x22 = XVECEXP (x12, 0, 1);
                      if (GET_CODE (x22) != MEM)
                        return -1;
                      x16 = XVECEXP (x12, 0, 0);
                      operands[2] = x16;
                      x23 = XEXP (x22, 0);
                      if (!rtx_equal_p (x23, operands[1]))
                        return -1;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern76 (x1, E_SImode) != 0)
                            return -1;
                          return 210; /* insn_fetchaddgez4 */

                        case E_DImode:
                          if (pattern76 (x1, E_DImode) != 0)
                            return -1;
                          return 211; /* insn_fetchaddgez */

                        default:
                          return -1;
                        }

                    case AND:
                      switch (pattern64 (x1))
                        {
                        case 0:
                          return 212; /* insn_fetchand4 */

                        case 1:
                          return 213; /* insn_fetchand */

                        default:
                          return -1;
                        }

                    case IOR:
                      switch (pattern64 (x1))
                        {
                        case 0:
                          return 214; /* insn_fetchor4 */

                        case 1:
                          return 215; /* insn_fetchor */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 23:
                  if (GET_MODE (x6) != E_DImode)
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != CLOBBER)
                    return -1;
                  x10 = XEXP (x4, 0);
                  if (GET_CODE (x10) != MEM
                      || GET_MODE (x10) != E_BLKmode)
                    return -1;
                  x11 = XEXP (x10, 0);
                  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x20 = XVECEXP (x6, 0, 0);
                  operands[1] = x20;
                  if (!u14bit_cint_operand (operands[1], E_DImode))
                    return -1;
                  return 362; /* insn_mfspr */

                default:
                  return -1;
                }

            case 2:
              if (XINT (x6, 1) != 209
                  || GET_MODE (x6) != E_DImode)
                return -1;
              x24 = XVECEXP (x6, 0, 1);
              if (GET_CODE (x24) != REG
                  || REGNO (x24) != 67
                  || GET_MODE (x24) != E_DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (pattern15 (x4, 67, CLOBBER) != 0
                  || !nonimmediate_operand (operands[0], E_DImode))
                return -1;
              x20 = XVECEXP (x6, 0, 0);
              operands[1] = x20;
              if (!netreg_operand (operands[1], E_DImode))
                return -1;
              return 517; /* *netreg_receive */

            default:
              return -1;
            }

        case UNSPEC:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x12 = XEXP (x4, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          switch (XVECLEN (x6, 0))
            {
            case 1:
              if (XINT (x6, 1) != 211)
                return -1;
              x20 = XVECEXP (x6, 0, 0);
              operands[1] = x20;
              x10 = XEXP (x4, 0);
              operands[2] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern57 (x6, E_SImode) != 0)
                    return -1;
                  return 521; /* stack_protect_setsi */

                case E_DImode:
                  if (pattern57 (x6, E_DImode) != 0)
                    return -1;
                  return 522; /* stack_protect_setdi */

                default:
                  return -1;
                }

            case 2:
              if (XINT (x6, 1) != 212)
                return -1;
              x20 = XVECEXP (x6, 0, 0);
              operands[1] = x20;
              x24 = XVECEXP (x6, 0, 1);
              operands[2] = x24;
              x10 = XEXP (x4, 0);
              operands[3] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern61 (x6, E_SImode) != 0)
                    return -1;
                  return 523; /* stack_protect_testsi */

                case E_DImode:
                  if (pattern61 (x6, E_DImode) != 0)
                    return -1;
                  return 524; /* stack_protect_testdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          switch (GET_CODE (x6))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
              res = recog_14 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case MEM:
              res = recog_15 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x6;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x12 = XEXP (x4, 1);
          if (GET_CODE (x12) != UNSPEC_VOLATILE)
            return -1;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          x10 = XEXP (x4, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (XVECLEN (x12, 0))
            {
            case 3:
              if (XINT (x12, 1) != 219)
                return -1;
              x22 = XVECEXP (x12, 0, 1);
              if (GET_CODE (x22) != REG
                  || REGNO (x22) != 66)
                return -1;
              x25 = XVECEXP (x12, 0, 2);
              operands[2] = x25;
              x16 = XVECEXP (x12, 0, 0);
              if (!rtx_equal_p (x16, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern71 (x12, E_SImode) != 0)
                    return -1;
                  return 527; /* atomic_compare_and_swap_baresi */

                case E_DImode:
                  if (pattern71 (x12, E_DImode) != 0)
                    return -1;
                  return 528; /* atomic_compare_and_swap_baredi */

                default:
                  return -1;
                }

            case 1:
              switch (XINT (x12, 1))
                {
                case 220:
                  x16 = XVECEXP (x12, 0, 0);
                  operands[2] = x16;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern62 (x12, E_SImode) != 0)
                        return -1;
                      return 529; /* atomic_exchange_baresi */

                    case E_DImode:
                      if (pattern62 (x12, E_DImode) != 0)
                        return -1;
                      return 530; /* atomic_exchange_baredi */

                    default:
                      return -1;
                    }

                case 218:
                  x16 = XVECEXP (x12, 0, 0);
                  switch (GET_CODE (x16))
                    {
                    case PLUS:
                      switch (pattern59 (x12))
                        {
                        case 0:
                          return 531; /* atomic_fetch_add_baresi */

                        case 1:
                          return 534; /* atomic_fetch_add_baredi */

                        default:
                          return -1;
                        }

                    case IOR:
                      switch (pattern59 (x12))
                        {
                        case 0:
                          return 532; /* atomic_fetch_or_baresi */

                        case 1:
                          return 535; /* atomic_fetch_or_baredi */

                        default:
                          return -1;
                        }

                    case AND:
                      switch (pattern59 (x12))
                        {
                        case 0:
                          return 533; /* atomic_fetch_and_baresi */

                        case 1:
                          return 536; /* atomic_fetch_and_baredi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      x4 = XVECEXP (x1, 0, 1);
      if (pattern15 (x4, 55, USE) != 0
          || !
#line 2671 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(reload_completed))
        return -1;
      return 160; /* _return */

    case UNSPEC_VOLATILE:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 2:
          if (XINT (x2, 1) != 25
              || GET_MODE (x2) != E_DImode)
            return -1;
          x10 = XEXP (x4, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_BLKmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x26 = XVECEXP (x2, 0, 0);
          operands[0] = x26;
          if (!u14bit_cint_operand (operands[0], E_DImode))
            return -1;
          x27 = XVECEXP (x2, 0, 1);
          operands[1] = x27;
          if (!reg_or_0_operand (operands[1], E_DImode))
            return -1;
          return 363; /* insn_mtspr */

        case 1:
          if (XINT (x2, 1) != 38)
            return -1;
          x10 = XEXP (x4, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_BLKmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x26 = XVECEXP (x2, 0, 0);
          operands[0] = x26;
          if (!pointer_operand (operands[0], E_VOIDmode))
            return -1;
          return 515; /* insn_wh64 */

        case 3:
          if (XINT (x2, 1) != 210
              || GET_MODE (x2) != E_DImode)
            return -1;
          x28 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x28) != REG
              || REGNO (x28) != 67
              || GET_MODE (x28) != E_DImode)
            return -1;
          x10 = XEXP (x4, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 67
              || GET_MODE (x10) != E_DImode)
            return -1;
          x26 = XVECEXP (x2, 0, 0);
          operands[0] = x26;
          if (!netreg_operand (operands[0], E_DImode))
            return -1;
          x27 = XVECEXP (x2, 0, 1);
          switch (GET_CODE (x27))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x27;
              if (!reg_or_cint_operand (operands[1], E_DImode))
                return -1;
              return 518; /* *netreg_send */

            case PLUS:
              if (GET_MODE (x27) != E_DImode)
                return -1;
              x29 = XEXP (x27, 0);
              operands[1] = x29;
              if (!reg_or_0_operand (operands[1], E_DImode))
                return -1;
              x30 = XEXP (x27, 1);
              operands[2] = x30;
              if (!add_operand (operands[2], E_DImode))
                return -1;
              return 519; /* *netreg_adddi_to_network */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_13 (x1, insn, pnum_clobbers);

    case ZERO_EXTRACT:
      if (GET_MODE (x2) == E_DImode)
        {
          res = recog_3 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern17 (x2))
        {
        case 0:
          return 32; /* *zero_extractsi */

        case 1:
          return 33; /* *zero_extractdi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_10 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_6 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern16 (x2, E_DImode) != 0)
            return -1;
          if (
#line 1268 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
(INTVAL (operands[3]) == 0 && INTVAL (operands[2]) == 32))
            return 34; /* *sign_extract_low32 */
          return 36; /* *sign_extract */

        case E_SImode:
          if (pattern16 (x2, E_SImode) != 0)
            return -1;
          return 35; /* *sign_extract */

        default:
          return -1;
        }

    case PLUS:
      return recog_8 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_11 (x1, insn, pnum_clobbers);

    case MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern0 (x2, E_SImode) != 0)
            return -1;
          return 40; /* subsi3 */

        case E_DImode:
          if (pattern0 (x2, E_DImode) != 0)
            return -1;
          return 41; /* subdi3 */

        case E_V8QImode:
          if (pattern0 (x2, E_V8QImode) != 0)
            return -1;
          return 445; /* subv8qi3 */

        case E_V4HImode:
          if (pattern0 (x2, E_V4HImode) != 0)
            return -1;
          return 452; /* subv4hi3 */

        case E_V2SImode:
          if (pattern1 (x2, E_V2SImode) != 0)
            return -1;
          return 460; /* subv2si3 */

        default:
          return -1;
        }

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !reg_or_0_operand (operands[1], E_SImode))
            return -1;
          return 43; /* negsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !reg_or_0_operand (operands[1], E_DImode))
            return -1;
          return 44; /* negdi2 */

        default:
          return -1;
        }

    case SS_PLUS:
      switch (pattern2 (x1))
        {
        case 0:
          return 46; /* ssaddsi3 */

        case 1:
          return 451; /* ssaddv4hi3 */

        case 2:
          return 459; /* ssaddv2si3 */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern2 (x1))
        {
        case 0:
          return 48; /* sssubsi3 */

        case 1:
          return 450; /* sssubv4hi3 */

        case 2:
          return 458; /* sssubv2si3 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern5 (x1))
        {
        case 0:
          return 50; /* ashlsi3 */

        case 1:
          return 51; /* ashldi3 */

        case 2:
          return 431; /* ashlv8qi3 */

        case 3:
          return 440; /* ashlv4hi3 */

        case 4:
          return 462; /* ashlv2si3 */

        case 5:
          return 136; /* *ashldi_truncdisi */

        case 6:
          return 137; /* *ashlsi_truncdisi */

        case 7:
          return 138; /* *ashlsi_truncdisi2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern4 (x2))
        {
        case 0:
          return 53; /* ashrsi3 */

        case 1:
          return 54; /* ashrdi3 */

        case 2:
          return 432; /* ashrv8qi3 */

        case 3:
          return 441; /* ashrv4hi3 */

        case 4:
          return 463; /* ashrv2si3 */

        case 5:
          return 139; /* *ashrdi3_truncdisi */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern5 (x1))
        {
        case 0:
          return 56; /* lshrsi3 */

        case 1:
          return 57; /* lshrdi3 */

        case 2:
          return 433; /* lshrv8qi3 */

        case 3:
          return 442; /* lshrv4hi3 */

        case 4:
          return 464; /* lshrv2si3 */

        case 5:
          return 142; /* *lshrdi_truncdisi */

        case 6:
          return 140; /* *lshrsi_truncdisi */

        case 7:
          return 141; /* *lshrsi_truncdisi2 */

        default:
          return -1;
        }

    case ROTATE:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          if (!reg_or_u6bit_operand (operands[2], E_SImode))
            return -1;
          return 59; /* rotldi3 */

        case TRUNCATE:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!reg_or_u6bit_operand (operands[2], E_DImode))
            return -1;
          return 143; /* *rotldi_truncdisi */

        default:
          return -1;
        }

    case IOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ASHIFT:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x8 = XEXP (x4, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !u16bit_or_const_symbolic_operand (operands[2], E_DImode))
            return -1;
          return 60; /* insn_shl16insli */

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern31 (x2, E_SImode) != 0)
                return -1;
              return 93; /* iorsi3 */

            case E_DImode:
              if (pattern31 (x2, E_DImode) != 0)
                return -1;
              return 94; /* iordi3 */

            case E_V8QImode:
              if (pattern31 (x2, E_V8QImode) != 0)
                return -1;
              return 95; /* iorv8qi3 */

            case E_V4HImode:
              if (pattern31 (x2, E_V4HImode) != 0)
                return -1;
              return 96; /* iorv4hi3 */

            case E_V2SImode:
              if (pattern31 (x2, E_V2SImode) != 0)
                return -1;
              return 97; /* iorv2si3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
      switch (pattern6 (x1))
        {
        case 0:
          if (reg_or_0_operand (operands[1], E_SImode)
              && reg_or_cint_operand (operands[2], E_SImode))
            return 63; /* insn_cmpne_sisi */
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_cint_operand (operands[2], E_DImode))
            return -1;
          return 64; /* insn_cmpne_disi */

        case 1:
          if (reg_or_0_operand (operands[1], E_SImode)
              && reg_or_cint_operand (operands[2], E_SImode))
            return 65; /* insn_cmpne_sidi */
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_cint_operand (operands[2], E_DImode))
            return -1;
          return 66; /* insn_cmpne_didi */

        case 2:
          return 446; /* snev8qi3 */

        case 3:
          return 453; /* snev4hi3 */

        default:
          return -1;
        }

    case EQ:
      switch (pattern9 (x1))
        {
        case 0:
          if (reg_or_0_operand (operands[1], E_SImode)
              && reg_or_cint_operand (operands[2], E_SImode))
            return 67; /* insn_cmpeq_sisi */
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_cint_operand (operands[2], E_DImode))
            return -1;
          return 68; /* insn_cmpeq_disi */

        case 1:
          if (reg_or_0_operand (operands[1], E_SImode)
              && reg_or_cint_operand (operands[2], E_SImode))
            return 69; /* insn_cmpeq_sidi */
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_cint_operand (operands[2], E_DImode))
            return -1;
          return 70; /* insn_cmpeq_didi */

        case 2:
          return 428; /* seqv8qi3 */

        case 3:
          return 437; /* seqv4hi3 */

        default:
          return -1;
        }

    case LT:
      switch (pattern9 (x1))
        {
        case 0:
          if (reg_or_0_operand (operands[1], E_SImode)
              && reg_or_cint_operand (operands[2], E_SImode))
            return 71; /* insn_cmplts_sisi */
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_cint_operand (operands[2], E_DImode))
            return -1;
          return 72; /* insn_cmplts_disi */

        case 1:
          if (reg_or_0_operand (operands[1], E_SImode)
              && reg_or_cint_operand (operands[2], E_SImode))
            return 73; /* insn_cmplts_sidi */
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_cint_operand (operands[2], E_DImode))
            return -1;
          return 74; /* insn_cmplts_didi */

        case 2:
          return 429; /* sltv8qi3 */

        case 3:
          return 438; /* sltv4hi3 */

        default:
          return -1;
        }

    case LTU:
      switch (pattern9 (x1))
        {
        case 0:
          if (reg_or_0_operand (operands[1], E_SImode)
              && reg_or_cint_operand (operands[2], E_SImode))
            return 75; /* insn_cmpltu_sisi */
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_cint_operand (operands[2], E_DImode))
            return -1;
          return 76; /* insn_cmpltu_disi */

        case 1:
          if (reg_or_0_operand (operands[1], E_SImode)
              && reg_or_cint_operand (operands[2], E_SImode))
            return 77; /* insn_cmpltu_sidi */
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_cint_operand (operands[2], E_DImode))
            return -1;
          return 78; /* insn_cmpltu_didi */

        case 2:
          return 430; /* sltuv8qi3 */

        case 3:
          return 439; /* sltuv4hi3 */

        default:
          return -1;
        }

    case LE:
      switch (pattern6 (x1))
        {
        case 0:
          if (reg_or_0_operand (operands[1], E_SImode)
              && reg_or_cint_operand (operands[2], E_SImode))
            return 79; /* insn_cmples_sisi */
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_cint_operand (operands[2], E_DImode))
            return -1;
          return 80; /* insn_cmples_disi */

        case 1:
          if (reg_or_0_operand (operands[1], E_SImode)
              && reg_or_cint_operand (operands[2], E_SImode))
            return 81; /* insn_cmples_sidi */
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_cint_operand (operands[2], E_DImode))
            return -1;
          return 82; /* insn_cmples_didi */

        case 2:
          return 447; /* slev8qi3 */

        case 3:
          return 454; /* slev4hi3 */

        default:
          return -1;
        }

    case LEU:
      switch (pattern6 (x1))
        {
        case 0:
          if (reg_or_0_operand (operands[1], E_SImode)
              && reg_or_cint_operand (operands[2], E_SImode))
            return 83; /* insn_cmpleu_sisi */
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_cint_operand (operands[2], E_DImode))
            return -1;
          return 84; /* insn_cmpleu_disi */

        case 1:
          if (reg_or_0_operand (operands[1], E_SImode)
              && reg_or_cint_operand (operands[2], E_SImode))
            return 85; /* insn_cmpleu_sidi */
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !reg_or_cint_operand (operands[2], E_DImode))
            return -1;
          return 86; /* insn_cmpleu_didi */

        case 2:
          return 448; /* sleuv8qi3 */

        case 3:
          return 455; /* sleuv4hi3 */

        default:
          return -1;
        }

    case AND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern36 (x2, E_SImode) != 0)
                return -1;
              return 87; /* andsi3 */

            case E_V8QImode:
              if (pattern36 (x2, E_V8QImode) != 0)
                return -1;
              return 88; /* andv8qi3 */

            case E_V4HImode:
              if (pattern36 (x2, E_V4HImode) != 0)
                return -1;
              return 89; /* andv4hi3 */

            case E_V2SImode:
              if (pattern36 (x2, E_V2SImode) != 0)
                return -1;
              return 90; /* andv2si3 */

            case E_DImode:
              if (pattern36 (x2, E_DImode) != 0)
                return -1;
              return 92; /* anddi3 */

            default:
              return -1;
            }

        case NOT:
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != NOT)
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern40 (x2, E_SImode) != 0)
                return -1;
              return 387; /* insn_nor_si */

            case E_DImode:
              if (pattern40 (x2, E_DImode) != 0)
                return -1;
              return 388; /* insn_nor_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern31 (x2, E_SImode) != 0)
            return -1;
          return 99; /* xorsi3 */

        case E_DImode:
          if (pattern31 (x2, E_DImode) != 0)
            return -1;
          return 100; /* xordi3 */

        case E_V8QImode:
          if (pattern31 (x2, E_V8QImode) != 0)
            return -1;
          return 101; /* xorv8qi3 */

        case E_V4HImode:
          if (pattern31 (x2, E_V4HImode) != 0)
            return -1;
          return 102; /* xorv4hi3 */

        case E_V2SImode:
          if (pattern31 (x2, E_V2SImode) != 0)
            return -1;
          return 103; /* xorv2si3 */

        default:
          return -1;
        }

    case CLZ:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      return 105; /* clzdi2 */

    case CTZ:
      switch (pattern11 (x1))
        {
        case 0:
          return 106; /* ctzsi2 */

        case 1:
          return 107; /* ctzdi2 */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern11 (x1))
        {
        case 0:
          return 108; /* popcountsi2 */

        case 1:
          return 109; /* popcountdi2 */

        default:
          return -1;
        }

    case BSWAP:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      return 110; /* bswapdi2 */

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !reg_or_0_operand (operands[1], E_SImode))
            return -1;
          return 111; /* one_cmplsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !reg_or_0_operand (operands[1], E_DImode))
            return -1;
          return 112; /* one_cmpldi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || !reg_or_0_operand (operands[1], E_V8QImode))
            return -1;
          return 113; /* one_cmplv8qi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !reg_or_0_operand (operands[1], E_V4HImode))
            return -1;
          return 114; /* one_cmplv4hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x2) != E_V2SImode
              || !reg_or_0_operand (operands[1], E_V2SImode))
            return -1;
          return 115; /* one_cmplv2si2 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          switch (GET_CODE (x4))
            {
            case NE:
            case EQ:
              res = recog_5 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x4;
          if (!signed_comparison_operator (operands[1], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          x9 = XEXP (x4, 0);
          operands[2] = x9;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case LABEL_REF:
              x6 = XEXP (x2, 2);
              if (GET_CODE (x6) != PC)
                return -1;
              x7 = XEXP (x5, 0);
              operands[0] = x7;
              if (reg_or_0_operand (operands[2], E_SImode))
                return 169; /* *bcc_normalsi */
              if (!reg_or_0_operand (operands[2], E_DImode))
                return -1;
              return 170; /* *bcc_normaldi */

            case PC:
              x6 = XEXP (x2, 2);
              if (GET_CODE (x6) != LABEL_REF)
                return -1;
              x10 = XEXP (x6, 0);
              operands[0] = x10;
              if (reg_or_0_operand (operands[2], E_SImode))
                return 171; /* *bcc_reversesi */
              if (!reg_or_0_operand (operands[2], E_DImode))
                return -1;
              return 172; /* *bcc_reversedi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x4;
          switch (pattern10 (x2))
            {
            case 0:
              if (move_operand (operands[1], E_QImode))
                return 120; /* zero_extendqisi2 */
              if (!move_operand (operands[1], E_HImode))
                return -1;
              return 122; /* zero_extendhisi2 */

            case 1:
              if (move_operand (operands[1], E_QImode))
                return 121; /* zero_extendqidi2 */
              if (move_operand (operands[1], E_HImode))
                return 123; /* zero_extendhidi2 */
              if (!move_operand (operands[1], E_SImode))
                return -1;
              return 124; /* zero_extendsidi2 */

            default:
              return -1;
            }

        case TRUNCATE:
          if (pattern21 (x2, E_DImode) != 0)
            return -1;
          return 133; /* *zero_extendsidi_truncdisi */

        case UNSPEC:
          switch (pattern28 (x2))
            {
            case 0:
              return 254; /* insn_ldnt1u */

            case 1:
              return 256; /* insn_ldnt2u */

            case 2:
              return 258; /* insn_ldnt4u */

            case 3:
              return 278; /* insn_ld1u_L2 */

            case 4:
              return 280; /* insn_ld2u_L2 */

            case 5:
              return 282; /* insn_ld4u_L2 */

            case 6:
              return 299; /* insn_ldnt1u_L2 */

            case 7:
              return 301; /* insn_ldnt2u_L2 */

            case 8:
              return 303; /* insn_ldnt4u_L2 */

            case 9:
              return 323; /* insn_ld1u_miss */

            case 10:
              return 325; /* insn_ld2u_miss */

            case 11:
              return 327; /* insn_ld4u_miss */

            case 12:
              return 344; /* insn_ldnt1u_miss */

            case 13:
              return 346; /* insn_ldnt2u_miss */

            case 14:
              return 348; /* insn_ldnt4u_miss */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!reg_or_0_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode)
                return -1;
              return 130; /* truncdisi2 */

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode)
                return -1;
              return 131; /* truncdihi2 */

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode)
                return -1;
              return 132; /* truncdiqi2 */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x4, 0) != 2
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x11 = XVECEXP (x4, 0, 0);
          operands[1] = x11;
          if (!reg_or_0_operand (operands[1], E_DImode))
            return -1;
          x12 = XVECEXP (x4, 0, 1);
          operands[2] = x12;
          if (!reg_or_0_operand (operands[2], E_DImode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 157:
              return 503; /* *insn_v1sadu */

            case 164:
              return 512; /* *insn_v2sads */

            case 165:
              return 514; /* *insn_v2sadu */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      return recog_9 (x1, insn, pnum_clobbers);

    case UMAX:
      if (pattern12 (x1) != 0)
        return -1;
      return 426; /* umaxv8qi3 */

    case UMIN:
      if (pattern12 (x1) != 0)
        return -1;
      return 427; /* uminv8qi3 */

    case SMAX:
      if (pattern13 (x1) != 0)
        return -1;
      return 435; /* smaxv4hi3 */

    case SMIN:
      if (pattern13 (x1) != 0)
        return -1;
      return 436; /* sminv4hi3 */

    case US_MINUS:
      if (pattern14 (x1) != 0)
        return -1;
      return 443; /* ussubv8qi3 */

    case US_PLUS:
      if (pattern14 (x1) != 0)
        return -1;
      return 444; /* usaddv8qi3 */

    case SS_ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!reg_or_0_operand (operands[2], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !reg_or_0_operand (operands[1], E_V4HImode))
            return -1;
          return 457; /* ssashlv4hi3 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x2) != E_V2SImode
              || !reg_or_0_operand (operands[1], E_V2SImode))
            return -1;
          return 465; /* ssashlv2si3 */

        default:
          return -1;
        }

    case VEC_SELECT:
      return recog_7 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_12 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_17 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 7:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != UNSPEC
              || XVECLEN (x3, 0) != 2
              || XINT (x3, 1) != 214)
            return -1;
          x4 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 0)
            return -1;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 0)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 25)
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x8) != CLOBBER)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 26)
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 27)
            return -1;
          x12 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x12) != CLOBBER)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 28)
            return -1;
          x14 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != REG
              || REGNO (x15) != 29)
            return -1;
          x16 = XVECEXP (x1, 0, 6);
          if (GET_CODE (x16) != CLOBBER)
            return -1;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 55)
            return -1;
          x18 = XVECEXP (x3, 0, 0);
          operands[0] = x18;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (pattern78 (x1, E_SImode) != 0)
                return -1;
              return 24; /* *tls_gd_call_32bit */

            case E_DImode:
              if (pattern78 (x1, E_DImode) != 0)
                return -1;
              return 25; /* *tls_gd_call */

            default:
              return -1;
            }

        case 3:
          x6 = XVECEXP (x1, 0, 1);
          if (pattern15 (x6, 54, USE) != 0)
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x8) != CLOBBER)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 55
              || GET_MODE (x9) != E_DImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case CALL:
              x5 = XEXP (x2, 0);
              if (GET_CODE (x5) != MEM
                  || GET_MODE (x5) != E_DImode)
                return -1;
              x19 = XEXP (x5, 0);
              operands[0] = x19;
              x3 = XEXP (x2, 1);
              operands[1] = x3;
              if (call_address_operand (operands[0], E_SImode))
                return 150; /* *call_insn */
              if (!call_address_operand (operands[0], E_DImode))
                return -1;
              return 151; /* *call_insn */

            case SET:
              x3 = XEXP (x2, 1);
              if (GET_CODE (x3) != CALL)
                return -1;
              x20 = XEXP (x3, 0);
              if (GET_CODE (x20) != MEM
                  || GET_MODE (x20) != E_DImode)
                return -1;
              x5 = XEXP (x2, 0);
              operands[0] = x5;
              if (!register_operand (operands[0], E_VOIDmode))
                return -1;
              x21 = XEXP (x20, 0);
              operands[1] = x21;
              x22 = XEXP (x3, 1);
              operands[2] = x22;
              if (call_address_operand (operands[1], E_SImode))
                return 152; /* *call_value_insn */
              if (!call_address_operand (operands[1], E_DImode))
                return -1;
              return 153; /* *call_value_insn */

            default:
              return -1;
            }

        case 2:
          return recog_16 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 201:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 162; /* blockage */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!reg_or_0_operand (operands[0], E_DImode))
                return -1;
              return 197; /* insn_dtlbpr */

            case 13:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!pointer_operand (operands[0], E_VOIDmode))
                return -1;
              return 216; /* insn_finv */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!pointer_operand (operands[0], E_VOIDmode))
                return -1;
              return 217; /* insn_flush */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 218; /* insn_flushwb */

            case 16:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 219; /* insn_fnop */

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 227; /* insn_drain */

            case 17:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!pointer_operand (operands[0], E_VOIDmode))
                return -1;
              return 228; /* insn_icoh */

            case 18:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 229; /* insn_ill */

            case 19:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!s8bit_cint_operand (operands[0], E_DImode))
                return -1;
              return 230; /* insn_info */

            case 20:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!s16bit_cint_operand (operands[0], E_DImode))
                return -1;
              return 231; /* insn_infol */

            case 21:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!pointer_operand (operands[0], E_VOIDmode))
                return -1;
              return 232; /* insn_inv */

            case 26:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 386; /* insn_nap */

            case 27:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!pointer_operand (operands[0], E_VOIDmode))
                return -1;
              return 389; /* insn_prefetch_l1_fault */

            case 28:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!pointer_operand (operands[0], E_VOIDmode))
                return -1;
              return 390; /* insn_prefetch_l2_fault */

            case 29:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!pointer_operand (operands[0], E_VOIDmode))
                return -1;
              return 391; /* insn_prefetch_l3_fault */

            case 208:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 516; /* tilegx_network_barrier */

            default:
              return -1;
            }

        case 3:
          if (pnum_clobbers == NULL
              || XINT (x1, 1) != 210
              || GET_MODE (x1) != E_DImode)
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 67
              || GET_MODE (x8) != E_DImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!netreg_operand (operands[0], E_DImode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x6;
              if (!reg_or_cint_operand (operands[1], E_DImode))
                return -1;
              *pnum_clobbers = 1;
              return 518; /* *netreg_send */

            case PLUS:
              if (GET_MODE (x6) != E_DImode)
                return -1;
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              if (!reg_or_0_operand (operands[1], E_DImode))
                return -1;
              x23 = XEXP (x6, 1);
              operands[2] = x23;
              if (!add_operand (operands[2], E_DImode))
                return -1;
              *pnum_clobbers = 1;
              return 519; /* *netreg_adddi_to_network */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 167; /* nop */

    case TRAP_IF:
      x24 = XEXP (x1, 0);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x25 = XEXP (x1, 1);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 168; /* trap */

    case PREFETCH:
      x24 = XEXP (x1, 0);
      operands[0] = x24;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      x25 = XEXP (x1, 1);
      operands[1] = x25;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x26 = XEXP (x1, 2);
      operands[2] = x26;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      return 178; /* prefetch */

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      switch (pattern17 (x3))
        {
        case 0:
          if (!
#line 1248 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
( reload_completed))
            return NULL;
          return gen_split_1 (insn, operands);

        case 1:
          if (!
#line 1248 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
( reload_completed))
            return NULL;
          return gen_split_2 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      switch (pattern17 (x3))
        {
        case 0:
          if (!
#line 1279 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
( reload_completed))
            return NULL;
          return gen_split_3 (insn, operands);

        case 1:
          if (!
#line 1279 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
( reload_completed))
            return NULL;
          return gen_split_4 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 2019 "../../gcc-8.1.1-20180626/gcc/config/tilegx/tilegx.md"
( reload_completed && register_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_5 (insn, operands);

    default:
      return NULL;
    }
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
